
# ifndef Component_h
# define Component_h Component_h

# include "Root.h"  // parent

namespace Conjecture {

  /// \class Component
  ///
  /// \brief The abstract superclass of all Component classes.
  ///
  /// An entire hierarchy of classes is generated for every algorithm
  /// identified as potentially beneficial to OCR functionality. Each
  /// such hierarchy implements a set of strategies for solving the
  /// algorithm represented by the hierarchy.
  ///
  /// This is a parent of all Component classes, just in case we need
  /// to introduce functionality common to all, or need to be able to
  /// store an arbitrary Component into a variable.

  class Component : public Root {
  public:
      // Constructors/Destructors
      Component();

      // Accessors

      // Input/Output

      // Miscellaneous

  protected:
      // Accessors

      // Methods 
   
  private: 
      // Accessors

      // Methods 

      // State
  };
}

# endif // Component_h

