# ifndef FormatComponent_h
# define FormatComponent_h FormatComponent_h

# include "Component.h" // parent

namespace Conjecture {
  class Page;

  /// \class FormatComponent
  ///
  /// \brief The abstract superclass of a hierarchy of classes
  /// implementing the 'format' algorithm, which is minimally
  /// responsible for generating properly positioned unicode text
  /// output.
  ///
  /// This algorithm is the first one called by StandardProcess.
  class FormatComponent : public Component {
  public:
    // Constructors/Destructors
    FormatComponent();
    virtual bool execute(Page* page) = 0;
  };
}

# endif // FormatComponent_h

