# ifndef SegmentComponent_h
# define SegmentComponent_h SegmentComponent_h

# include "Component.h" // parent

namespace Conjecture {
  class Page;

  /// \class SegmentComponent
  ///
  /// \brief The abstract superclass of a hierarchy of classes
  /// implementing the 'partition' algorithm, which is minimally
  /// responsible for identifying the sub-regions of the Page that
  /// represent individual Glyphs.  The algorithm may do more than
  /// just identify Glyphs however (i.e. may also identify Words,
  /// Lines and/or Regions too).
  ///
  /// This algorithm is the first one called by StandardProcess.
  class SegmentComponent : public Component {
  public:
    SegmentComponent();
    virtual bool execute(Page* page) = 0;
  };
}

# endif // SegmentComponent_h

