# ifndef DefaultModule_h
# define DefaultModule_h DefaultModule_h

// #####################################################################
// # Conjecture: An Extensible Optical Character Recognition Framework #
// #                                                                   #
// # Copyright: Lesser GNU Public License (LGPL)                       #
// #                                                                   #
// # Overview:                                                         #
// #  - Conjecture is a collection of C++ classes, and an OCR engine   #
// #  - Conjecture is designed to allow customization at all levels    #
// #    and to encourage individuals to contribute incremental         #
// #    improvements in algorithms.                                    #
// #  - Overall design discussions can be found in                     #
// #      $SNROOT/docs/doxygen/html/index.html                         #
// #  - Conjecture is designed to interact with and build on other     #
// #    open-source OCR programs.                                      #
// #####################################################################

//
# include "GocrModule.h" // parent

namespace Conjecture {

    /*****************************************************************
     * \class DefaultModule
     *
     * \brief
     *
     * ...
     *
     *****************************************************************/
    class DefaultModule : public GocrModule {
      public:
	// Constructors/Destructors
	DefaultModule();
    
	// **************
	// Interface
	virtual ProcessComponent*     createProcessComponent() const;
	virtual SegmentComponent*     createSegmentComponent() const;
	virtual IdentifyComponent*    createIdentifyComponent() const;
	virtual FormatComponent*      createFormatComponent() const;
    };
}

# endif // DefaultModule_h

