# ifndef GocrFormat_h
# define GocrFormat_h GocrFormat_h

# include "FormatComponent.h" // parent

namespace Conjecture {
  class Page;

  /// \class GocrFormat
  ///
  /// \brief The abstract superclass of a hierarchy of classes
  /// implementing the 'partition' algorithm, which is minimally
  /// responsible for identifying the sub-regions of the Page that
  /// represent individual Glyphs.  The algorithm may do more than
  /// just identify Glyphs however (i.e. may also identify Words,
  /// Lines and/or Regions too).
  ///
  /// This algorithm is the first one called by StandardProcess.
  class GocrFormat : public FormatComponent {
  public:
    GocrFormat();
    virtual bool execute(Page* page);
  };
}

# endif // GocrFormat_h

