# ifndef GocrSegment_h
# define GocrSegment_h GocrSegment_h

# include "SegmentComponent.h" // parent

namespace Conjecture {
  class Page;

  /// \class GocrSegment
  ///
  /// \brief The abstract superclass of a hierarchy of classes
  /// implementing the 'Segment' algorithm, which is minimally
  /// responsible for identifying the sub-regions of the Page that
  /// represent individual Glyphs.  The algorithm may do more than
  /// just identify Glyphs however (i.e. may also identify Words,
  /// Lines and/or Regions too).
  ///
  /// This algorithm is the first one called by StandardProcess.
  class GocrSegment : public SegmentComponent {
  public:
    GocrSegment();
    virtual bool execute(Page* page);
    
  };
}

# endif // GocrSegment_h

