# ifndef WmhModule_h
# define WmhModule_h WmhModule_h

/// TODO: INSERT HEADER HERE

# include "GocrModule.h" // parent

namespace Conjecture {
    
    /********************************************************************
     * \class WmhModule
     *
     * \brief Wade's first experiment with OCR
     *
     * Currently relying on Gocr for various components, this
     * OCR will incrementally migrate away from a reliance on gocr
     * as Wade finds more time to work on various ideas.
     *
     * This Module must currently be a subclass of GocrModule because
     * WmhSegment delegates to GocrSegment, and GocrSegment requires
     * the module to be a GocrModule so that 'JOB' exists.
     *
     ********************************************************************/
    class WmhModule : public GocrModule {
      public:
        WmhModule();
        
        // **************
        // Interface
        virtual ProcessComponent*     createProcessComponent() const;
        virtual SegmentComponent*     createSegmentComponent() const;
        virtual IdentifyComponent*    createIdentifyComponent() const;
        virtual FormatComponent*      createFormatComponent() const;
    };
}

# endif // WmhModule_h

