#include "Debug.h"

using namespace Conjecture;

Debug::Debug() : _level(Debug::DEBUG_LEVEL_NONE), _outStream(&std::cout) {
    ; // empty
}

Debug::~Debug() {
    this->outStream()->flush();
}

void Debug::header(verboseLevel l) {
    *this << levelToString(l);
}

Debug & Debug::operator<< (const std::string &str) {
    *this->outStream() << str;
    return *this;
}

Debug & Debug::operator<< (const char *str) {
    *this->outStream() << str;
    return *this;
}
