# ifndef SomeClass_ImageFilter_h
# define SomeClass_ImageFilter_h SomeClass_ImageFilter_h

// ####################################################################
// # Conjecture: An Extensible Optical Character Recognition Framework  #
// #                                                                  #
// # Copyright: Lesser GNU Public License (LGPL)                      #
// #                                                                  #
// # Overview:                                                        #
// #  - Conjecture is a collection of C++ classes, and an OCR engine    #
// #  - Conjecture is designed to allow customization at all levels     #
// #    and to encourage individuals to contribute incremental        #
// #    improvements in algorithms.                                   #
// #  - Overall design discussions can be found in                    #
// #      $SNROOT/docs/doxygen/html/index.html                        #
// #  - Conjecture is designed to interact with and build on other      #
// #    open-source OCR programs.                                     #
// ####################################################################

# include "Root.h"  // parent

namespace Conjecture {

  class Bitmap;

  // ##################################################################
  /// \class ImageFilter
  ///
  /// \brief
  ///
  /// ...
  // ##################################################################
  class ImageFilter : public Root {
  public:
    // Constructors/Destructors
    ImageFilter();

    // **************
    // Accessors

    // **************
    // Input/Output

    // **************
    // Interface

    /**
     *
     * @param b The image to process
     */
    virtual bool filter(Bitmap &b) = 0;

  protected:
    // **************
    // Accessors

    // **************
    // Methods

  private:
    // **************
    // Accessors

    // **************
    // Methods

    // **************
    // State
  };
}

# endif // SomeClass_h

