# ifndef Root_h
# define Root_h Root_h

// A very temporary macro providing simple conditional debugging.
// Cannot be emulated in C++. The 'code' can be anything that can be
// placed at the location [inner] in the following statement:
//    cerr << [inner] << endl;
#define DBG(lvl,code) if (debug>=(lvl)) { cerr << code << endl; }

namespace Conjecture {
    /*********************************************************************
     * \class Root
     *
     * \brief The abstract superclass of all classes in the Conjecture
     * namespace.
     *
     * Functionality defined here is available in every Conjecture class,
     * obviously. Primarily debugging and other low-level functionality.
     *
     ********************************************************************/

    // NOTE: 
    //  - Is it acceptable to clutter up the Conjecture namespace with
    //    these?
    //
    //  - These typedefs are a point of contention between certain project leaders
    //    (bruno and wade). They may exist temporarily, and be
    //    replaced with their uint*_t equivalents when intense coding
    //    has lessend.
    typedef unsigned char uint8_t;
    typedef unsigned short uint16_t;
    typedef unsigned int uint32_t;

    typedef uint8_t  u1;
    typedef uint16_t u2;
    typedef uint32_t u4;

    class Root {
      public:
        // Constructors/Destructors
        Root();
        
        // Accessors
        
        // Input/Output
        
        // Miscellaneous
        
      protected:
        // Methods 

        // Accessors

      private: 
        // Methods 
        
        // Accessors
        
        // State
    };
};

# endif // Root_h

