
# include <iostream>
# include "Word.h"  

using namespace std;

namespace Conjecture {
    Word::Word(Element* parent, const Coord& topleft, const Coord& bottomright) : Element(parent, topleft, bottomright) {
    }
    
    void Word::printSummary(ostream& os, const string& indent, int index) const {
	this->Element::printSummary(os,indent,index);
    }
    
    void Word::writeText(ostream& os) const {
        // NOTE: Words are NOT currently responsible for inserting
        // spaces, because they should not be inserted after the last
        // word in a line. The Line class performs both inter-word and
        // end-of-line insertions.
        for (ElementList::const_iterator it = this->parts().begin(); it != this->parts().end(); ++it) {
            (*it)->writeText(os);
        }
    }
    
    void Word::test(int argc, const char* argv[]) {
	cerr << "ERROR: Not unit test for Word - FIX THIS!" << endl;
    }

};
