# ifndef StrManip_h
# define StrManip_h StrManip_h

// Created 2006/06/11 by wade

# include "Root.h"  // parent

namespace Conjecture {
    
    /******************************************************************
     * \class StrManip
     *
     * \brief Various string manipulation routines
     *
     * This class will almost certainly be restructured and
     * incorporated into a cleaner design - just a placeholder for
     * useful string-related methods for now.
     *
     *******************************************************************/
    class StrManip : public Root {
      public:
        // Constructors/Destructors
        StrManip();
        
        // Accessors
        
        // Input/Output
        
        // Interface

        /************************************************************
         * Perform optimal string matching between two strings.
         * 
         * \param str1 out parameter - string will be modified to
         * provide better alignment
         *
         * \param str2 out parameter - string will be modified to
         * provide better alignment
         *
         * This method takes two strings and determines where to
         * insert "spaces" within each so as to maximize the amount of
         * character-to-character matching between them.
         *
         */
        static void MatchStrings(const std::string& str1, const std::string& str2, std::string& outstr1, std::string& outstr2, char insert = '_');

        /**
         * Merge two multi-line strings into a single string.
         *
         * Each line of the strings are concatenated with 'indent' as
         * filler. This produces readable results only if at least the
         * first input string has fixed-length strings.
         *
         * FUTURE FIX: This may be moved to a string-related class.
         *
         */
        static std::string MergeStrings(const std::string& str1, const std::string& str2, const std::string& indent = " ");

        static void Test(int argc = 0, const char* argv[] = NULL);
        
      protected:
        // Methods 
        
        // Accessors
        
      private: 
        // Methods 
        static void PrintMatrix(int** D, unsigned m, unsigned n);

        // Accessors

        // State
    };
}

# endif // StrManip_h

