# ifndef System_h
# define System_h System_h

# include "Root.h"  // parent

namespace Conjecture {

    /*******************************************************************
     * \class System
     *
     * \brief Interface to system-related functionality
     *
     * Must try to make this work on all platforms!
     *
     *******************************************************************/
  class System : public Root {
  public:
    // Constructors/Destructors
    System();

    // Accessors
    
    // Input/Output
    
    // Interface

    /**
     * Ensure that a directory with given path exists. Create if
     * necessary.
     *
     * If 'dirpath' is not absolute, the directory created is
     * relative to the current directory.
     *
     * Returns true if it already exists or creation was successful,
     * false on error.
     *
     */
    static bool Mkdir(const std::string& dirpath);

    /**
     * Ensure that a directory for the file specified in path exists.
     * Create if necessary.
     *
     * The 'path' is assumed to specify a file (which may or may not
     * exist). This method ensures that the directory within which
     * this file resides exists (creating if necessary).
     *
     * Returns true if it already exists or creation was successful,
     * false on error.
     *
     */
    static bool Mkpath(const std::string& filepath);

    /**
     * Execute the given command in a sub-shell.
     *
     * Returns true if the subshell process exits with a 0, false
     * otherwise. Handling of errors is handled by the function
     * itself.
     *
     */
    static bool ShellCommand(const std::string& command);

  protected:
    // Accessors
    
    // Methods 
    
  private: 
    // Accessors
    
    // Methods 

    // State
  };
}

# endif // System_h

