<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Conjecture - a general OCR framework</title>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-15">
  <!-- link rel="icon" href="conjecture.ico" type="image/x-icon" -->
  <!-- link rel="shortcut icon" href="conjecture.ico" type="image/x-icon" -->
  <link rel="stylesheet" href="style.css" type="text/css" title="plain">
</head>
<body>
<table class="nopad" align="left" border="0" cellpadding="0"
 cellspacing="0" width="100%">
  <tbody>
    <tr>
      <td class="nopad">
<?php 
 $mainvalue='Home';
 $subvalue='';
 include_once("header.php");
?>
      </td>
    </tr>
    <tr>
      <td>
      
      <table class="nopad" align="left" border="0" cellpadding="0" cellspacing="0" width="100%">
        <tbody>
          <tr valign="top">
            <td class="content">

<!-- ****************************************************************** -->

<div id="about">
  <h2> An Overview of Conjecture </h2>
  <blockquote>

    <p> 
    Conjecture is an open-source C++ framework for optical
    character recognition. It is not a single OCR, it is an extensible
    collection of OCRs that can be explored, modified, analyzed and
    compared within the Conjecture environment.
    </p>

    <p>
    Conjecture provides support for incorporating commercial
    third-party OCRs into its infrastructure, and provides much more
    sophisticated support for incorporating open-source OCRs.  In
    particular, where possible, Conjecture provides access to the
    underlying code base of individual OCR implementations, allowing
    Conjecture developers to build on top of existing functionality,
    and to mix-and-match functionality from among various OCRs.
    Conjecture makes it easy to assess, compare, and improve existing
    OCRs.
    </p>

    <p>
    The philosophy behind the design of Conjecture differs somewhat from
    most other OCR projects. OCR is a difficult problem, and no one
    strategy for character recognition is optimal, given the vast amount
    variation possible in input (differing fonts, font sizes, noise
    levels, orientation angles, existence of interspersed text and
    pictures, and numerous other concepts that affect OCR accuracy). One
    strategy might excel for one document, while a very different strategy
    may be better for another document. Most existing open-source OCRs use
    a single hard-coded strategy, and make it difficult for individuals to
    contribute and experiment with variations in algorithms without
    becoming intimately familiar with the entire architecture. 
    </p>

    <p>
    In constrast, Conjecture provides a modular design that makes it
    possible for an individual to start experimenting and exploring
    possible improvements immediately. Conjecture is an object-oriented
    C++ framework designed from the beginning to allow for intuitive,
    incremental customization at many different levels. As with any
    framework, customization occurs by creating a subclass of one or more
    of the classes provided by the framework.
    </p>

  </blockquote>
</div>

<!-- ****************************************************************** -->

<div id="features">
  <h2>Features</h2>
  <blockquote>
    <ul>

      <li> Conjecture is built around a collection of OCR Modules.

        <ul>

         <li> Each Module provides a complete solution to the problem
         of converting an input image into output text.

         <li> Each Module is implemented by a C++ "module" class, which
         uses a number of additional "component" classes that implement
         solutions to the various subproblems associated with OCR).
         </li>

         <li> When the <code>conjecture</code> executable is invoked,
         the user specifies which OCR Module will be used. Conjecture is
         not a single OCR, but rather an arbitrarily large collection of
         OCRs.

         <li> Conjecture can create a Module that "wraps" an arbitrary
         third-party OCR, thus allowing that OCR to participate in the
         Conjecture framework.

         <li> Conjecture provides Modules for third-party open-source
         OCRs like GOCR, Ocrad and Claraocr that incorporate their code
         bases into Conjecture. This allows Conjecture to benefit from and
         build on top of existing OCR development.

       </ul>

      <li> Conjecture provides a sophisticated testing infrastructure that:
        <ul>

          <li> Maintains a database of input images and associated text
          files representing what an OCR should produce if it is 100%
          accurate.

          <li> Formalizes the concept of a <em>Module Variant</em>, which
          concists of a particular OCR Module and a set of values for the
          <em>configurable parameters</em> associated with that Module.

          <li> Allows users to execute one or more variants of one or more
          OCR modules on one or more input images.
         
          <li> Allows one to verify that a particular change in the
          Conjecture code base has not caused unexpected consequences.
          This is accomplished by invoking <code>conjecture</code> on all
          variants of all modules on all input images and comparing the
          output of each run against <em>expected</em> output.

          <li> Allows one to establish the accuracy of one or more
          module/variant/image triples by comparing generated output
          against <em>desired</em> output.
               
        </ul>
      </li>

      <li> Conjecture makes it easy for individuals to make Conjecture
      better. 

       <ul>

          <li> Conjecture is open source, and read/write accessible (via a
          Subversion repository) to all who are interested in advancing
          the state-of-the-art in optical character recognition.</li>

          <li> Conjecture provides an infrastructure that allows
          non-programmers to experiment with different configurable
          parameters, and to record the combination of parameter values
          that produce the best results. Over time, the best possible
          combination of input parameters for each module/image
          continually evolves.</li>
            

          <li> Conjecture uses an object-oriented design emphasizing
          modularity, making it easy for programmers to make everything
          from tiny incremental changes in a single method of an existing
          Component, to entirely new Modules that implement everything
          necessary for image-to-text conversion.
           <ul>

             <li> Modules (and the associated Components) are described
             by an entry in a special <code>Conjecture.modules</code>
             file.

             <li> Conjecture can automatically and fully generate the
             module class based on the entry in the modules file.

             <li> A Module can reuse components that have already been
             developed for some other Module, or can create new ones.

             <li> Conjecture automatically produces a stub class for
             each new component. These stub classes can then be edited in
             order to provide a new implementation if the issue being
             addressed by the Component in question.

           </ul>
          </li>
        </ul>
     
      </li>
    </ul>
  </blockquote>
</div>

<!-- ****************************************************************** -->

<div id="news">
  <h1>News</h1>
  <blockquote>
  <dl>
    <dt><a name="12062006"></a>12 Jun 2006</dt>
    <dd>

    Initial version of this website.

    </dd>

    <dt><a name="02062006"></a>02 June 2006</dt>
    <dd>

    Project started.

    </dd>

  </dl>
  </blockquote>
</div>

<!-- ****************************************************************** -->

            </td>

            <!-- begin side bar -->
            <td class="right" width="200">
<?php 
 include_once("sidebar.php");
?>

            </td>
            
            <!-- end side bar -->

          </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td class="nopad">
<?php 
 include_once("footer.php");
?>
      </td>
    </tr>
  </tbody>
</table>



</body>
</html>
