<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Conjecture - Documentation - Terminology</title>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-15">
  <!-- link rel="icon" href="conjecture.ico" type="image/x-icon" -->
  <!-- link rel="shortcut icon" href="conjecture.ico" type="image/x-icon" -->
  <link rel="stylesheet" href="style.css" type="text/css" title="plain">
</head>
<body>
<table class="nopad" align="left" border="0" cellpadding="0"
 cellspacing="0" width="100%">
  <tbody>
    <tr>
      <td class="nopad">
<?php
 $mainvalue='Documentation';
 $subvalue='Terminology';
 include_once("header.php");
?>
      </td>
    </tr>
    <tr>
      <td>

      <table class="nopad" align="left" border="0" cellpadding="0" cellspacing="0" width="100%">
        <tbody>
          <tr valign="top">
            <td class="content">

	    <h1>Conjecture Terminology</h1>
	    <blockquote>
              <dl>

                <dt>component</dt>
                <dd>
                A formalization of an issue that needs to be addressed
                in order to provide image-to-text conversion. Each
                component has a canonical name and generates an entire
                class hierarchy within the Conjecture framework. For
                example, one issue of importance is 'glyph
                identification', which has been formalized into the
                <code>IdentifyComponent</code> component. The
                <code>IdentifyComponent</code> class provides an
                interface that "resolves" or "addressed" the issue.
                Subclasses of <code>IdentifyComponent</code> provide
                alternative implementations of this interface. A
                particular Module will use a specific subclass of
                <code>IdentifyComponent</code> to provide glyph
                identification.
                </dd>

                <dt>component implementation</dt>
                <dd>
                For a component <code>SomeName</code>, an implementation is a
                subclass of the <code>SomeName</code>Component interface.
                </dd>

                <dt>glyph segmentation</dt>
                <dd>
                 The identification of the regions within a Page
                 representing individual Glyphs. Glyph segmentation is
                 not the same as Glyph identification, but instead
                 necessarily preceeds it.
                 </dd>

                <dt>glyph identification</dt>
                <dd>
                The process of converting a graphic image representing
                a character (a Glyph) into a unicode value. It is at
                the core of any OCR program. Its efficacy depends not
                only on its internal strategies, but also the accuracy
                of Glyph segmentation. If a region is identified as a
                Glyph, but is instead only part of a glyph, or
                multiple glyphs, the accuracy of identification will
                inevitably decline.
                </dd>

                <dt>horizontal</dt>
                <dd>
                The direction that aligns glyphs within a line.
                Normally, this is just the x direction, but if the
                image is rotated, then 'horizontal' refers to the x
                direction after this rotation has been compensated
                for.
                </dd>

                <dt>issue</dt>
                <dd>
                Some concept or problem of importance during optical
                character recognition. A conceptual term. Examples of
                issues include segmentation, identification,
                formatting, dust removal, line angle detection, etc.
                </dd>

                <dt>line segmentation</dt>
                <dd>
                The identification of the regions within a Page
                representing individual Lines of horizontally
                adjacent Glyphs. Line segmentation may occur before
                or after Glyph segmentation, depending on the overall
                segmentation strategy employed.
                </dd>

                <dt>OCR</dt>
                <dd>
                This term is used in two different contexts within
                Conjecture. It can mean "optical character
                recognition" (a verb), or it can mean "optical
                character recognizer" (a noun). The OCR class
                hierarchy uses the noun semantics - each subclass of
                OCR is an optical character recognizer (that performs
                optical character recognition :-) Optical character
                recognition involves taking an image as input, and
                producing formatted text as output.
                </dd>

                <dt>strategy</dt>
                <dd>
                Synonynm for 'implementation'

                <dt>vertical</dt>
                <dd>
                The direction orthogonal to horizontal.  It too is
		affected by page rotation issues.
                </dd>

              </dl>

	    </blockquote>

	    </td>

	    <!-- begin side bar -->
            <td class="right" width="200">
<?php
 include_once("sidebar.php");
?>

	    </td>

   	    <!-- end side bar -->

	  </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td class="nopad">
<?php
 include_once("footer.php");
?>
      </td>
    </tr>
  </tbody>
</table>


</body>
</html>
