package Meta::Doc::Lib::PlotGroup;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Doc::Lib::CompositePlot);
use Meta::Doc::Lib::CompositePlot;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Plot;

###
# The executable code of this class (methods, accessors, initializers, finalizers)

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.PlotGroup.__C5__(Meta!Vec<Meta.Doc.Lib.PlotP>P)
#line 642 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::PlotGroup::new(Meta!Str class, Meta!Vec<Meta.Doc.Lib.Plot*>* initial = undef)'; carp("ERROR: $__meta_sig:\n       Expecting between 1 and 2 arguments but found " . scalar(@_) . ".") if ( ( @_ < 1 ) || ( @_ > 2 ) );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $initial = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'initial' = '$initial' should have ref 'ARRAY' but has ref '" . CORE::ref($initial) . "'") unless ( ( !defined($initial)) || ( CORE::ref($initial) eq 'ARRAY'));
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.PlotGroup.__C5__(Meta!Vec<Meta.Doc.Lib.PlotP>P)SCOPE
#   line 643 "graph.meta"

    if ( $initial ) {
      foreach my $plot (@$initial) {
        $self->registerPlot($plot);
      }
    }
    # Inserted by Meta
    return $self;

}

#instance METHOD 'writeGnuplot'
# METALINE: Meta.Doc.Lib.PlotGroup.writeGnuplot(Meta!StrVMeta!StrV)
#line 650 "graph.meta"
sub writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::PlotGroup::writeGnuplot(Meta.Doc.Lib.PlotGroup#* self, Meta!Str@ filebase, Meta!Str@ type)'; carp("ERROR: $__meta_sig:\n       Expecting 3 arguments but found " . scalar(@_) . ".") if ( @_ != 3 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PlotGroup'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PlotGroup') ) ) );
    my $filebase = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'filebase' = '$filebase' should have ref '' but has ref '" . CORE::ref($filebase) . "'") unless ( ( !defined($filebase)) || ( CORE::ref($filebase) eq ''));
    my $type = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #

    # METALINE: Meta.Doc.Lib.PlotGroup.writeGnuplot(Meta!StrVMeta!StrV)SCOPE
#   line 661 "graph.meta"

    #####
    ## Propogate vars
    $self->propogateGnuplotVars();

    #####
    ## Make the individual plots
    my $i = 0;
    my @gps;
    foreach my $plot (@{$self->plots()}) {
      ++$i;
      my $subbase = sprintf("$filebase%02d",$i);
      push(@gps, "$subbase.gp");
      $plot->writeGnuplot($subbase, $type);
    }

    #####
    ## Make a control file for the entire group of plots
    if ( @gps ) {
      my $gps = join(' ', @gps);
      print(STDERR "SYSTEM: cat $gps > $filebase.gp\n");
      system("cat $gps > $filebase.gp");
    }

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
    });
}


#line 685 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for PlotGroup (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">PlotGroup.out");
        close(STDERR); open(STDERR, ">PlotGroup.err");
    }

    # Start of user-provided code
#line 685 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
    
    
      my $plot = Meta::Doc::Lib::Plot->new('First  example title', 'X-axis label', 'Y-axis label');
      my ($p1,$p2,$p3) = $plot->createMappings('Line1', 'Line2', 'Line3');
      foreach my $i (1,2,3,4,5) {
        $plot->addMultiPoint($i, $i+1, 2*$i+2, 3*$i+3);
      }
    
      my $plot2 = Meta::Doc::Lib::Plot->new('Second example title', 'X-axis label', 'Y-axis label');
      $plot2->createMappings('Line1', 'Line2', 'Line3');
      foreach my $i (1,2,3,4,5) {
        $plot2->addMultiPoint($i, $i+10, 2*$i+15, 3*$i+17);
      }
    
      my $plots = Meta::Doc::Lib::PlotGroup->new();
      $plots->registerPlot($plot);
      $plots->registerPlot($plot2);
      $plots->write('Data/plotgroup');
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'PlotGroup.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat PlotGroup.out"); } unlink('PlotGroup.out') unless ( $verbose > 2);
        if ( ( -s 'PlotGroup.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat PlotGroup.err"); } unlink('PlotGroup.err') unless ( $verbose > 2);
    }

}

#line 685 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS PlotGroup\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
