package Meta::Doc::Lib::PlotInterface;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Lib::Object);
use Meta::Lib::Object;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Axis;
use Meta::Doc::Lib::PointMap;
use Meta::Doc::Lib::Function;

###
# The executable code of this class (methods, accessors, initializers, finalizers)

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.PlotInterface.__C1__()
#line 24 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::PlotInterface::new(Meta!Str class)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.PlotInterface.__C1__()SCOPE
#   line 25 "graph.meta"
    # Inserted by Meta
    return $self;

}

#instance METHOD 'writeGnuplot'
# METALINE: Meta.Doc.Lib.PlotInterface.writeGnuplot(Meta!StrVMeta!StrV)
#line 27 "graph.meta"
sub writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::PlotInterface::writeGnuplot(Meta.Doc.Lib.PlotInterface#* self, Meta!Str@ filebase, Meta!Str@ type)'; carp("ERROR: $__meta_sig:\n       Expecting 3 arguments but found " . scalar(@_) . ".") if ( @_ != 3 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PlotInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PlotInterface') ) ) );
    my $filebase = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'filebase' = '$filebase' should have ref '' but has ref '" . CORE::ref($filebase) . "'") unless ( ( !defined($filebase)) || ( CORE::ref($filebase) eq ''));
    my $type = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #

    # METALINE: Meta.Doc.Lib.PlotInterface.writeGnuplot(Meta!StrVMeta!StrV)SCOPE
#   line 27 "graph.meta"
$_[0]->__meta_subclassResponsibility("Meta.Doc.Lib::PlotInterface::writeGnuplot(Meta.Doc.Lib.PlotInterface#* self, Meta!Str@ filebase, Meta!Str@ type)");
}
    # METALINE: PlotInterface.GnuplotVariables.varsSet
#   line 37 "graph.meta"
sub varsSet { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'varsSet()'\n"); $_[0]->{__meta_varsSet} = $_[1]; } else { return $_[0]->{__meta_varsSet}; } }
sub varsSetVal { return $_[0]->{__meta_varsSet}; }
sub getVarsSet { return $_[0]->{__meta_varsSet}; }
sub setVarsSet { $_[0]->{__meta_varsSet} = $_[1]; }
sub varsSetSet { $_[0]->{__meta_varsSet} = $_[1]; printf(STDERR "WARNING: Using deprecated varsSetSet setter\n"); }
sub varsSetIs { $_[0]->{__meta_varsSet} = $_[1]; }
sub varsSetRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'varsSet()'\n"); $_[0]->{__meta_varsSet} = $_[1]; } else { return $_[0]->{__meta_varsSet}; } }
sub getVarsSetElement { return $_[0]->{__meta_varsSet}->{$_[1]}; }
sub varsSetElement { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'varsSetElement()'\n"); $_[0]->{__meta_varsSet}->{$_[1]} = $_[2]; } else { return $_[0]->{__meta_varsSet}->{$_[1]}; } }
sub setVarsSetElement { $_[0]->{__meta_varsSet}->{$_[1]} = $_[2]; }
sub numVarsSet { return scalar(keys(%{$_[0]->{__meta_varsSet}})); }
sub getVarsSetElementKeys { return (wantarray) ? keys(%{$_[0]->{__meta_varsSet}}) : [keys(%{$_[0]->{__meta_varsSet}})]; }
sub getVarsSetElementValues { return (wantarray) ? values(%{$_[0]->{__meta_varsSet}}) : [values(%{$_[0]->{__meta_varsSet}})]; }

#instance METHOD 'setGnuplotVar'
# METALINE: Meta.Doc.Lib.PlotInterface.setGnuplotVar(Meta!StrCRMeta!StrCR)
#line 44 "graph.meta"
sub setGnuplotVar {
    my $__meta_sig = 'Meta.Doc.Lib::PlotInterface::setGnuplotVar(Meta.Doc.Lib.PlotInterface#* self, Meta!Str#& var, Meta!Str#& val)'; carp("ERROR: $__meta_sig:\n       Expecting 3 arguments but found " . scalar(@_) . ".") if ( @_ != 3 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PlotInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PlotInterface') ) ) );
    my $var = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'var' = '$var' should have ref '' but has ref '" . CORE::ref($var) . "'") unless ( ( !defined($var)) || ( CORE::ref($var) eq ''));
    my $val = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'val' = '$val' should have ref '' but has ref '" . CORE::ref($val) . "'") unless ( ( !defined($val)) || ( CORE::ref($val) eq ''));
    #

    # METALINE: Meta.Doc.Lib.PlotInterface.setGnuplotVar(Meta!StrCRMeta!StrCR)SCOPE
#   line 47 "graph.meta"

      $self->varsSetRef()->{$var} = $val;

}

#instance METHOD 'mergeGnuplotVars'
# METALINE: Meta.Doc.Lib.PlotInterface.mergeGnuplotVars(Meta!MapP)
#line 50 "graph.meta"
sub mergeGnuplotVars {
    my $__meta_sig = 'Meta.Doc.Lib::PlotInterface::mergeGnuplotVars(Meta.Doc.Lib.PlotInterface#* self, Meta!Map* vars)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PlotInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PlotInterface') ) ) );
    my $vars = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'vars' = '$vars' should have ref 'HASH' but has ref '" . CORE::ref($vars) . "'") unless ( ( !defined($vars)) || ( CORE::ref($vars) eq 'HASH'));
    #

    # METALINE: Meta.Doc.Lib.PlotInterface.mergeGnuplotVars(Meta!MapP)SCOPE
#   line 56 "graph.meta"

      my $varset = $self->varsSet();
      foreach my $var (keys(%$vars)) {
        my $val = $varset->{$var};
        if ( ! defined($val) ) {
          $self->setGnuplotVar($var, $vars->{$var});
        }
      }

}

#instance METHOD 'useSmallFonts'
# METALINE: Meta.Doc.Lib.PlotInterface.useSmallFonts()
#line 65 "graph.meta"
sub useSmallFonts {
    my $__meta_sig = 'Meta.Doc.Lib::PlotInterface::useSmallFonts(Meta.Doc.Lib.PlotInterface#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PlotInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PlotInterface') ) ) );
    #

    # METALINE: Meta.Doc.Lib.PlotInterface.useSmallFonts()SCOPE
#   line 66 "graph.meta"

      $self->setGnuplotVar('terminal', 'x11 font "5x8"');

}

#instance METHOD 'noAxisLabels'
# METALINE: Meta.Doc.Lib.PlotInterface.noAxisLabels()
#line 69 "graph.meta"
sub noAxisLabels {
    my $__meta_sig = 'Meta.Doc.Lib::PlotInterface::noAxisLabels(Meta.Doc.Lib.PlotInterface#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PlotInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PlotInterface') ) ) );
    #

    # METALINE: Meta.Doc.Lib.PlotInterface.noAxisLabels()SCOPE
#   line 70 "graph.meta"

      $self->setGnuplotVar('xlabel', '');
      $self->setGnuplotVar('ylabel', '');

}

#instance METHOD 'write'
# METALINE: Meta.Doc.Lib.PlotInterface.write(Meta!StrVMeta!StrVMeta!StrV)
#line 76 "graph.meta"
sub write {
    my $__meta_sig = 'Meta.Doc.Lib::PlotInterface::write(Meta.Doc.Lib.PlotInterface#* self, Meta!Str@ filebase, Meta!Str@ format = \'gnuplot\', Meta!Str@ type = \'linespoints\')'; carp("ERROR: $__meta_sig:\n       Expecting between 2 and 4 arguments but found " . scalar(@_) . ".") if ( ( @_ < 2 ) || ( @_ > 4 ) );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PlotInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PlotInterface') ) ) );
    my $filebase = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'filebase' = '$filebase' should have ref '' but has ref '" . CORE::ref($filebase) . "'") unless ( ( !defined($filebase)) || ( CORE::ref($filebase) eq ''));
    my $format = $_[2]; $format = 'gnuplot' unless defined($format); carp("ERROR: $__meta_sig:\n       Arg 'format' = '$format' should have ref '' but has ref '" . CORE::ref($format) . "'") unless ( ( !defined($format)) || ( CORE::ref($format) eq ''));
    my $type = $_[3]; $type = 'linespoints' unless defined($type); carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #

    # METALINE: Meta.Doc.Lib.PlotInterface.write(Meta!StrVMeta!StrVMeta!StrV)SCOPE
#   line 82 "graph.meta"

    if ( $format eq 'gnuplot' ) {
      $self->writeGnuplot($filebase, $type);
    } else {
      die("Exception: Unknown format '$format'");
    }

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_varsSet'     => {},
    });
}

sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for PlotInterface (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">PlotInterface.out");
        close(STDERR); open(STDERR, ">PlotInterface.err");
    }

    # Start of user-provided code
    print("No unit test has been provided for CLASS PlotInterface\n");
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'PlotInterface.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat PlotInterface.out"); } unlink('PlotInterface.out') unless ( $verbose > 2);
        if ( ( -s 'PlotInterface.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat PlotInterface.err"); } unlink('PlotInterface.err') unless ( $verbose > 2);
    }

}
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS PlotInterface\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
