package Meta::Doc::Lib::PointMap;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Doc::Lib::FunctionInterface);
use Meta::Doc::Lib::FunctionInterface;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Point;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: PointMap.map
#   line 859 "graph.meta"
sub map { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'map()'\n"); $_[0]->{__meta_map} = $_[1]; } else { return $_[0]->{__meta_map}; } }
sub mapVal { return $_[0]->{__meta_map}; }
sub getMap { return $_[0]->{__meta_map}; }
sub setMap { $_[0]->{__meta_map} = $_[1]; }
sub mapSet { $_[0]->{__meta_map} = $_[1]; printf(STDERR "WARNING: Using deprecated mapSet setter\n"); }
sub mapIs { $_[0]->{__meta_map} = $_[1]; }
sub mapRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'map()'\n"); $_[0]->{__meta_map} = $_[1]; } else { return $_[0]->{__meta_map}; } }
sub getMapElement { return $_[0]->{__meta_map}->{$_[1]}; }
sub mapElement { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'mapElement()'\n"); $_[0]->{__meta_map}->{$_[1]} = $_[2]; } else { return $_[0]->{__meta_map}->{$_[1]}; } }
sub setMapElement { $_[0]->{__meta_map}->{$_[1]} = $_[2]; }
sub numMap { return scalar(keys(%{$_[0]->{__meta_map}})); }
sub getMapElementKeys { return (wantarray) ? keys(%{$_[0]->{__meta_map}}) : [keys(%{$_[0]->{__meta_map}})]; }
sub getMapElementValues { return (wantarray) ? values(%{$_[0]->{__meta_map}}) : [values(%{$_[0]->{__meta_map}})]; }

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.PointMap.__C8__(Meta!StrCR)
#line 868 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::new(Meta!Str class, Meta!Str#& spec)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $spec = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'spec' = '$spec' should have ref '' but has ref '" . CORE::ref($spec) . "'") unless ( ( !defined($spec)) || ( CORE::ref($spec) eq ''));
    #
    my $self = $class->SUPER::new($spec);
    # METALINE: Meta.Doc.Lib.PointMap.__C8__(Meta!StrCR)SCOPE
#   line 870 "graph.meta"

    ## Parent constructor does everything needed.
    # Inserted by Meta
    return $self;

}

#instance METHOD 'addPoint'
# METALINE: Meta.Doc.Lib.PointMap.addPoint(Meta.Doc.Lib.PointP)
#line 878 "graph.meta"
sub addPoint {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::addPoint(Meta.Doc.Lib.PointMap#* self, Meta.Doc.Lib.Point* point)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my $point = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'point' = '$point' is not type compatible with 'Meta::Doc::Lib::Point'") unless ( ( ! $point ) || ( ref($point) && ( $point->isa('Meta::Doc::Lib::Point') ) ) );
    #

    # METALINE: Meta.Doc.Lib.PointMap.addPoint(Meta.Doc.Lib.PointP)SCOPE
#   line 879 "graph.meta"

      $self->addPoint2D($point);

}

#instance METHOD 'add'
# METALINE: Meta.Doc.Lib.PointMap.add(...V)
#line 882 "graph.meta"
sub add {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::add(Meta.Doc.Lib.PointMap#* self, ...@ data)'; carp("ERROR: $__meta_sig:\n       Expecting at least 1 arguments but found " . scalar(@_) . ".") if ( @_ < 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my @data = @_[1..$#_];
    #

    # METALINE: Meta.Doc.Lib.PointMap.add(...V)SCOPE
#   line 883 "graph.meta"

      $self->add2D(@data);

}

#instance METHOD 'addData'
# METALINE: Meta.Doc.Lib.PointMap.addData(Meta!VecP)
#line 886 "graph.meta"
sub addData {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::addData(Meta.Doc.Lib.PointMap#* self, Meta!Vec* data)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my $data = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'data' = '$data' should have ref 'ARRAY' but has ref '" . CORE::ref($data) . "'") unless ( ( !defined($data)) || ( CORE::ref($data) eq 'ARRAY'));
    #

    # METALINE: Meta.Doc.Lib.PointMap.addData(Meta!VecP)SCOPE
#   line 887 "graph.meta"

      $self->addData2D($data);

}

#instance METHOD 'addSpec'
# METALINE: Meta.Doc.Lib.PointMap.addSpec(Meta!StrV)
#line 890 "graph.meta"
sub addSpec {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::addSpec(Meta.Doc.Lib.PointMap#* self, Meta!Str@ spec)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my $spec = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'spec' = '$spec' should have ref '' but has ref '" . CORE::ref($spec) . "'") unless ( ( !defined($spec)) || ( CORE::ref($spec) eq ''));
    #

    # METALINE: Meta.Doc.Lib.PointMap.addSpec(Meta!StrV)SCOPE
#   line 891 "graph.meta"

      $self->addSpec2D($spec);

}

#instance METHOD 'addPoint2D'
# METALINE: Meta.Doc.Lib.PointMap.addPoint2D(Meta.Doc.Lib.PointP)
#line 902 "graph.meta"
sub addPoint2D {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::addPoint2D(Meta.Doc.Lib.PointMap#* self, Meta.Doc.Lib.Point* point)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my $point = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'point' = '$point' is not type compatible with 'Meta::Doc::Lib::Point'") unless ( ( ! $point ) || ( ref($point) && ( $point->isa('Meta::Doc::Lib::Point') ) ) );
    #

    # METALINE: Meta.Doc.Lib.PointMap.addPoint2D(Meta.Doc.Lib.PointP)SCOPE
#   line 903 "graph.meta"

      $self->map()->{$point->x()} = $point;

}

#instance METHOD 'add2D'
# METALINE: Meta.Doc.Lib.PointMap.add2D(...V)
#line 906 "graph.meta"
sub add2D {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::add2D(Meta.Doc.Lib.PointMap#* self, ...@ data)'; carp("ERROR: $__meta_sig:\n       Expecting at least 1 arguments but found " . scalar(@_) . ".") if ( @_ < 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my @data = @_[1..$#_];
    #

    # METALINE: Meta.Doc.Lib.PointMap.add2D(...V)SCOPE
#   line 907 "graph.meta"

      my $point = Meta::Doc::Lib::Point->new(@data);
      $self->addPoint2D($point);

}

#instance METHOD 'addData2D'
# METALINE: Meta.Doc.Lib.PointMap.addData2D(Meta!VecP)
#line 911 "graph.meta"
sub addData2D {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::addData2D(Meta.Doc.Lib.PointMap#* self, Meta!Vec* data)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my $data = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'data' = '$data' should have ref 'ARRAY' but has ref '" . CORE::ref($data) . "'") unless ( ( !defined($data)) || ( CORE::ref($data) eq 'ARRAY'));
    #

    # METALINE: Meta.Doc.Lib.PointMap.addData2D(Meta!VecP)SCOPE
#   line 915 "graph.meta"

      my $i = 0;
      while ($i < @$data) {
        my $p = Meta::Doc::Lib::Point->new($data->[$i], $data->[$i+1]);
        $self->addPoint2D($p);
        $i += 2;
      }

}

#instance METHOD 'addSpec2D'
# METALINE: Meta.Doc.Lib.PointMap.addSpec2D(Meta!StrV)
#line 923 "graph.meta"
sub addSpec2D {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::addSpec2D(Meta.Doc.Lib.PointMap#* self, Meta!Str@ spec)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my $spec = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'spec' = '$spec' should have ref '' but has ref '" . CORE::ref($spec) . "'") unless ( ( !defined($spec)) || ( CORE::ref($spec) eq ''));
    #

    # METALINE: Meta.Doc.Lib.PointMap.addSpec2D(Meta!StrV)SCOPE
#   line 930 "graph.meta"

      $spec =~ s/^\s*//;
      $spec =~ s/\s*$//;
      my $data = [split(/\s+/, $spec)];
      $self->addData2D($data);

}

#instance METHOD 'writeGnuplot'
# METALINE: Meta.Doc.Lib.PointMap.writeGnuplot(Meta!AnyP)
#line 940 "graph.meta"
sub writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::PointMap::writeGnuplot(Meta.Doc.Lib.PointMap#* self, Meta!Any* fp)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::PointMap'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::PointMap') ) ) );
    my $fp = $_[1];
    #

    # METALINE: Meta.Doc.Lib.PointMap.writeGnuplot(Meta!AnyP)SCOPE
#   line 944 "graph.meta"

      my $map = $self->map();

      ## Separate this data from others in the gnuplot data stream by
      ## two newlines, making it a new index.
      print($fp "\n\n# ", $self->asSpec(), "\n");
      my $xformat = $self->xaxis()->format();
      my $yformat = $self->yaxis()->format();
      my @x = sort { $a <=> $b } keys(%$map);
      foreach my $x (@x) {
        my $p = $map->{$x};
        $p->write($fp, $xformat, $yformat);
      }

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_map'         => {},
    });
}


#line 961 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for PointMap (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">PointMap.out");
        close(STDERR); open(STDERR, ">PointMap.err");
    }

    # Start of user-provided code
#line 961 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
    
    
      my $function = Meta::Doc::Lib::PointMap->new('age (type int) vs. height KEY line1');
      my $point = Meta::Doc::Lib::Point->new( 0, .3);
      $function->addPoint($point);
      $function->add(1, .5);
      $function->addData([2 => .7, 3 => .9]);
      $function->addSpec("
      4  1.1
      5  1.5
      6  1.8
    ");
    
      my $fp = \*STDOUT;
      $function->writeGnuplot($fp);
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'PointMap.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat PointMap.out"); } unlink('PointMap.out') unless ( $verbose > 2);
        if ( ( -s 'PointMap.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat PointMap.err"); } unlink('PointMap.err') unless ( $verbose > 2);
    }

}

#line 961 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS PointMap\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
