package Meta::Doc::Lib::Table;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Lib::Object);
use Meta::Lib::Object;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Oopl::BaseLanguage::PerlRef;
use Meta::Doc::Lib::Column;
use Meta::Doc::Lib::Plot;

###
# The executable code of this class (methods, accessors, initializers, finalizers)

###############################
# instance FIELD 'colMap'
# META: Meta.Doc.Lib.Table.colMap:*Meta!Map
sub colMap { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'colMap()'\n"); $_[0]->{__meta_colMap} = $_[1]; } else { return $_[0]->{__meta_colMap}; } }
sub colMapVal { return $_[0]->{__meta_colMap}; }
sub colMapIs { $_[0]->{__meta_colMap} = $_[1]; }
sub colMapRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'colMap()'\n"); $_[0]->{__meta_colMap} = $_[1]; } else { return $_[0]->{__meta_colMap}; } }

###############################
# instance FIELD 'colOrder'
# META: Meta.Doc.Lib.Table.colOrder:@Meta!Vec<@Meta!Str>
sub colOrder { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'colOrder()'\n"); $_[0]->{__meta_colOrder} = $_[1]; } else { return $_[0]->{__meta_colOrder}; } }
sub colOrderVal { return $_[0]->{__meta_colOrder}; }
sub colOrderIs { $_[0]->{__meta_colOrder} = $_[1]; }
sub colOrderRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'colOrder()'\n"); $_[0]->{__meta_colOrder} = $_[1]; } else { return $_[0]->{__meta_colOrder}; } }

###############################
# instance FIELD 'colWidths'
# META: Meta.Doc.Lib.Table.colWidths:*Meta!Map
sub colWidths { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'colWidths()'\n"); $_[0]->{__meta_colWidths} = $_[1]; } else { return $_[0]->{__meta_colWidths}; } }
sub colWidthsVal { return $_[0]->{__meta_colWidths}; }
sub colWidthsIs { $_[0]->{__meta_colWidths} = $_[1]; }
sub colWidthsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'colWidths()'\n"); $_[0]->{__meta_colWidths} = $_[1]; } else { return $_[0]->{__meta_colWidths}; } }

###############################
# instance FIELD 'rows'
# META: Meta.Doc.Lib.Table.rows:*Meta!Vec<*Meta!Map>
sub rows { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'rows()'\n"); $_[0]->{__meta_rows} = $_[1]; } else { return $_[0]->{__meta_rows}; } }
sub rowsVal { return $_[0]->{__meta_rows}; }
sub rowsIs { $_[0]->{__meta_rows} = $_[1]; }
sub rowsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'rows()'\n"); $_[0]->{__meta_rows} = $_[1]; } else { return $_[0]->{__meta_rows}; } }

###############################
# instance FIELD 'caption'
# META: Meta.Doc.Lib.Table.caption:@Meta!Str
sub caption { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'caption()'\n"); $_[0]->{__meta_caption} = $_[1]; } else { return $_[0]->{__meta_caption}; } }
sub captionVal { return $_[0]->{__meta_caption}; }
sub captionIs { $_[0]->{__meta_caption} = $_[1]; }
sub captionRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'caption()'\n"); $_[0]->{__meta_caption} = $_[1]; } else { return $_[0]->{__meta_caption}; } }

###############################
# instance FIELD 'name'
# META: Meta.Doc.Lib.Table.name:@Meta!Str
sub name { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'name()'\n"); $_[0]->{__meta_name} = $_[1]; } else { return $_[0]->{__meta_name}; } }
sub nameVal { return $_[0]->{__meta_name}; }
sub nameIs { $_[0]->{__meta_name} = $_[1]; }
sub nameRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'name()'\n"); $_[0]->{__meta_name} = $_[1]; } else { return $_[0]->{__meta_name}; } }

###############################
# instance FIELD 'defaults'
# META: Meta.Doc.Lib.Table.defaults:*Meta!Map
sub defaults { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'defaults()'\n"); $_[0]->{__meta_defaults} = $_[1]; } else { return $_[0]->{__meta_defaults}; } }
sub defaultsVal { return $_[0]->{__meta_defaults}; }
sub defaultsIs { $_[0]->{__meta_defaults} = $_[1]; }
sub defaultsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'defaults()'\n"); $_[0]->{__meta_defaults} = $_[1]; } else { return $_[0]->{__meta_defaults}; } }


###############################
# meta METHOD 'new'
# META: Meta.Doc.Lib.Table.new(@Meta!Str,*Meta!Map,@...@):void
sub new {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.new\(class\:\@Meta\!Str\,config\:\*Meta\!Map\,init\:\@\.\.\.\@\)\:void";
  my $class = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$class failed typechecking.  Possible reasons are:\n   - \$class must be defined and have ref '' (is '%s')",(defined($class)?ref($class):'undef'))) if ( (((!defined($class)) || (ref($class) ne ''))) );
  my $config = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$config failed typechecking.  Possible reasons are:\n   - \$config has ref '%s' when ref 'HASH' expected",(defined($config)?ref($config):'undef'))) if ( (((defined($config)) && (ref($config) ne 'HASH'))) );
  my @init = @_[2..$#_]; 

  my $self = $class->SUPER::new();
  #----------------------------
  # META: start of user-code
  ####
  ## Basics
  $self->nameIs( $config->{name} || '' );
  $self->captionIs( $config->{caption} || '' );
  my $defaults = $config->{defaults} || {};
  $self->defaultsIs($defaults);

  ####
  ## Create the set of Meta::Doc::Lib::Column instances based on info
  ## in @init
  my @order;
  my %map;
  my $i = 0;
  my $lastid;
  while ($i < @init) {
    my $v   = $init[$i];
    my $ref = ref($v);

    if ( ! $ref ) {
      ## We have a column id
      push(@order, $v);
      $lastid = $v;

    } elsif ( $ref eq 'HASH' ) {
      ## We have a hash modifying previous id
      if (defined($lastid)) {
        $map{$lastid} = Meta::Doc::Lib::Column->new($lastid, $v, $defaults);
      } else {
        die("ERROR: arg '$i' is a hash supposedly describing the id in the previous position, but that position is also a hash.");
      }
      $lastid = undef;

    } else {
      ## We don't know what we have
      die("ERROR: invalid arg '$i' (ref type '$ref') = $v");
    }
    ++$i;
  }

  ####
  ## Initialize any columns that have not already been explicitly
  ## initialized with hashes in @init
  foreach my $id (@order) {
    my $col = $map{$id};
    if ( ! defined($col) ) {
      $map{$id} = Meta::Doc::Lib::Column->new($id, {}, $defaults);
    }
  }

  ####
  ## Record the state
  $self->colOrderIs(\@order);
  $self->colMapIs(\%map);
  # META: end of user-code
  #----------------------------
  return $self;
}

###############################
# static METHOD 'newFromFp'
# META: Meta.Doc.Lib.Table.newFromFp(*Meta!Any,@...%):*Meta.Doc.Lib.Table
sub newFromFp {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.newFromFp\(fp\:\*Meta\!Any\,options\:\@\.\.\.\%\)\:\*Meta\.Doc\.Lib\.Table";
  my $fp = $_[0]; 
  my %options = @_[1..$#_]; 
  #----------------------------
  # META: start of user-code
  my $result;

  my $tableStart  = $options{tableStart} || qr/^\s*=+\s*$/;
  my $headerEnd   = $options{headerEnd}  || qr/^\s*-+\s*$/;
  my $filter      = $options{filter}     || qr/\|/;
  my $footerStart = $options{headerEnd}  || qr/^\s*-+\s*$/;
  my $tableEnd    = $options{tableStart} || qr/^\s*=+\s*$/;

  ####
  ## Scan forward in $fp for $tableStart
  while (<$fp>) {
    last if m/$tableStart/;
  }

  if ( ! eof($fp) ) {
    ####
    ## Scan forward for the end of the header (and start of data)
    my @header;
    while (<$fp>) {
      last if m/$headerEnd/;
      chomp();
      push(@header, $_);
    }

    if ( ! eof($fp) ) {
      ####
      ## Consume data lines until we encounter $footerStart or $tableEnd
      my @rows;
      while (<$fp>) {
        last if m/$footerStart/;
        last if m/$tableEnd/;
        s/$filter/ /g;
        chomp();
        my $row = [split(/\s+/, $_)];
        push(@rows, $row);
      }

      my @footer;
      if ( m/$footerStart/ ) {
        ## Scan forward for the end of table
        while (<$fp>) {
          last if m/$tableEnd/;
          chomp();
          push(@footer, $_);
        }
        if ( ! m/$tableEnd/ ) {
          die("ERROR: Failed to find end-of-table '$tableEnd' in input stream!\n");
        }
      }

      ####
      ## If we have made it this far, we have all the information
      ## we need to create a new instance, in the variables:
      ## @header (take first element and parse into column labels)
      ## @rows (already an array of values)
      ## @footer (take first element and parse into name and caption)
      my %config;
      my $footer = $footer[0];
      if ( $footer =~ m/^(.*\S)\s*:\s*(.*\S)/ ) {
        $config{name} = $1;
        $config{caption} = $2;
      } else {
        print(STDERR "WARN: Unknown footer '$footer'\n");
        $config{name} = 'Unknown';
        $config{caption} = 'Unknown';
      }
      my $header = $header[0];
      $header =~ s/$filter/ /g;
      my @cols = split(/\s+/, $header);
      $result = Meta::Doc::Lib::Table->new(\%config, @cols);
      foreach my $row (@rows) {
        my %row;
        foreach my $i (0..$#cols) {
          $row{ $cols[$i] } = $row->[$i];
        }
        $result->add(%row);
      }

    } else {
      die("ERROR: Failed to find end-of-header '$headerEnd' in input stream!\n");
    }

  } else {
    die("ERROR: Failed to find start-of-table '$tableStart' in input stream!\n");
  }

  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'colForId'
# META: Meta.Doc.Lib.Table.colForId(#*Meta.Doc.Lib.Table,@Meta!Str):*Meta.Doc.Lib.Column
sub colForId {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.colForId\(self\:\#\*Meta\.Doc\.Lib\.Table\,id\:\@Meta\!Str\)\:\*Meta\.Doc\.Lib\.Column";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my $id = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$id failed typechecking.  Possible reasons are:\n   - \$id must be defined and have ref '' (is '%s')",(defined($id)?ref($id):'undef'))) if ( (((!defined($id)) || (ref($id) ne ''))) );
  #----------------------------
  # META: start of user-code
  return $self->colMap()->{$id};
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'transpose'
# META: Meta.Doc.Lib.Table.transpose(#*Meta.Doc.Lib.Table,@Meta!Str):*Meta.Doc.Lib.Table
sub transpose {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.transpose\(self\:\#\*Meta\.Doc\.Lib\.Table\,id\:\@Meta\!Str\)\:\*Meta\.Doc\.Lib\.Table";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my $id = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$id failed typechecking.  Possible reasons are:\n   - \$id must be defined and have ref '' (is '%s')",(defined($id)?ref($id):'undef'))) if ( (((!defined($id)) || (ref($id) ne ''))) );
  #----------------------------
  # META: start of user-code
  my $result;
  my $col = $self->colForId($id);
  if ( $col ) {
    my $rows = $self->rows();
    ####
    ## Establish order of columns in new table
    my @neworder = ($id);
    foreach my $row (@$rows) {
      push(@neworder, $row->{$id});
    }
    ####
    ## Create the tablen
    $result = Meta::Doc::Lib::Table->new(
      { 
        name => ("Transposed " . $self->name()), 
        caption => ($self->caption()),
        defaults => $self->defaults(),
      },
      @neworder
    );
    ####
    ## Add one row to the new table for each column in the
    ## current table.
    my $order = $self->colOrder();
    foreach my $cid (@$order) {
      if ( $cid ne $id ) {
        ## We have a column $cid in current table, which we
        ## want to transpose.  We need to map $row->{$id}
        ## keys to row->{$cid} values (putting these key/value
        ## pairs into %newrow.  We also want to add to %newrow
        ## a mapping from $id to the label associated with the
        ## column identified by $cid.
        my %newrow;
        my $col = $self->colForId($cid);
        $newrow{$id} = $col->label();
        foreach my $row (@$rows) {
          my $tid = $row->{$id};
          $newrow{$tid} = $row->{$cid};
        }
        $result->add(%newrow);
      }
    }

  } else {
    print(STDERR "ERROR: Id '$id' does not exist in current table - cannot transpose on it\n");
    $result = undef;
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'makePlot'
# META: Meta.Doc.Lib.Table.makePlot(#*Meta.Doc.Lib.Table,@...%):*Meta.Doc.Lib.Plot
sub makePlot {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.makePlot\(self\:\#\*Meta\.Doc\.Lib\.Table\,options\:\@\.\.\.\%\)\:\*Meta\.Doc\.Lib\.Plot";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my %options = @_[1..$#_]; 
  #----------------------------
  # META: start of user-code
  my $xlabel    = $options{xlabel} || 'unknown xlabel';
  my $ylabel    = $options{ylabel} || 'unknown ylabel';
  my $selrows   = $options{rows};

  my $datacols  = $options{datacols};
  my $titlecols = $options{titlecols};
  my $xid       = $options{xcol};

  my $variant;
  if ( $datacols && $titlecols ) {
    $variant = 1;
  } elsif ( $datacols && defined($xid) ) {
    $variant = 2;
  } else {
    die("ERROR: Need more options to establish variant");
  }

  my $rows = $self->rows();
  my $plot;
  if ( $variant == 1 ) {
    $plot = Meta::Doc::Lib::Plot->new($self->caption(), $xlabel, $ylabel);

    my @selrows =  $selrows ? @$selrows : (0..$#$rows);
    foreach my $r (@selrows) {
      ## $row is a hash mapping column ids to values.  We are to make
      ## a PointMap for the data in this row.
      my $row = $rows->[$r];
      next unless defined($row);

      ## The title of the PointMap is composed of the values of the
      ## columns specified in $titlecols.
      my @title;
      foreach my $cid (@$titlecols) {
        my $col   = $self->colForId($cid);
        my $label = $col->label();
        my $val   = $row->{$cid};
        push(@title, "$label=$val");
      }
      my $title = join(' ', @title);

      ## We make the PointMap instances
      my $map = $plot->newMapping($title);

      ## The x-y values to add to the PointMap are defined by the
      ## values of the columns in $datacols. Actually, the 'x' values
      ## are the cids in $datacols (and thus they must be numbers!!!)
      ## and the y values are the corresponding column values for the
      ## row in question.
      foreach my $cid (@$datacols) {
        my $val = $row->{$cid} || 0;
        if ( $val eq '-' ) { $val = 0; }
        $map->add($cid, $row->{$cid});
      }
    } 

  } elsif ( $variant == 2 ) {
    $plot = Meta::Doc::Lib::Plot->new($self->caption(), $xlabel, $ylabel);
    my $rows = $self->rows();
    my @selrows = $selrows ? @$selrows : (0..$#$rows);
    my $xcol = $self->colForId($xid);
    foreach my $yid (@$datacols) {
      my $ycol  = $self->colForId($yid);
      my $title = $ycol->label();
      my $map   = $plot->newMapping($title);
      foreach my $r (@selrows) {
        my $row = $rows->[$r];
        next unless defined($row);
        $map->add( $row->{$xid}, $row->{$yid} );
      }
    }
  }

  return $plot;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'entryFor'
# META: Meta.Doc.Lib.Table.entryFor(#*Meta.Doc.Lib.Table,@Meta!Str,@Meta!Str,@Meta!Str):@Meta!Str
sub entryFor {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.entryFor\(self\:\#\*Meta\.Doc\.Lib\.Table\,keyId\:\@Meta\!Str\,keyval\:\@Meta\!Str\,valId\:\@Meta\!Str\)\:\@Meta\!Str";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my $keyId = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$keyId failed typechecking.  Possible reasons are:\n   - \$keyId must be defined and have ref '' (is '%s')",(defined($keyId)?ref($keyId):'undef'))) if ( (((!defined($keyId)) || (ref($keyId) ne ''))) );
  my $keyval = $_[2]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$keyval failed typechecking.  Possible reasons are:\n   - \$keyval must be defined and have ref '' (is '%s')",(defined($keyval)?ref($keyval):'undef'))) if ( (((!defined($keyval)) || (ref($keyval) ne ''))) );
  my $valId = $_[3]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$valId failed typechecking.  Possible reasons are:\n   - \$valId must be defined and have ref '' (is '%s')",(defined($valId)?ref($valId):'undef'))) if ( (((!defined($valId)) || (ref($valId) ne ''))) );
  #----------------------------
  # META: start of user-code
  my $result;
  my $src = $self->colForId($keyId);
  if ( $src ) {
    my $dest = $self->colForId($valId);
    if ( $dest ) {
      ## We have verified and found both the src and dest columns.
      ## We now search column $src for the row matching value
      ## '$keyval', and return the value in that row for
      ## column $dest.
      my $rows = $self->rows();
      my $index;
      foreach my $i (0..$#$rows) {
        my $row = $rows->[$i];
        my $v = $row->{$keyId};
        if ( ( defined($v) ) && ( $v eq $keyval ) ) {
          $index = $i;
          last;
        }
      }
      if ( defined($index) ) {
        $result = $rows->[$index]->{$valId};
      } else {
        print(STDERR "ERROR: Failed to find value '$keyval' in column '$keyId'\n");
      }

    } else {
      print(STDERR "ERROR: '$valId' is an invalid column id\n");
    }
  } else {
    print(STDERR "ERROR: '$keyId' is an invalid column id\n");
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'summary'
# META: Meta.Doc.Lib.Table.summary(#*Meta.Doc.Lib.Table):void
sub summary {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.summary\(self\:\#\*Meta\.Doc\.Lib\.Table\)\:void";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  #----------------------------
  # META: start of user-code
  my $table = Meta::Doc::Lib::Table->new(
    { name => 'Summary', caption => ("Column information for '" . $self->name() . ': ' . $self->caption() . "'" ) },
    'id', { name => 'ID' }, 'label', 'type', 'width', { align => 'center' }, 'align', 'default', 'ldelim', 'rdelim'
  );
  my $order = $self->colOrder();
  foreach my $id (@$order) {
    my $col = $self->colForId($id);
    $table->add( $col->summary() );
  }
  $table->print();
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'add'
# META: Meta.Doc.Lib.Table.add(#*Meta.Doc.Lib.Table,@...%):void
sub add {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.add\(self\:\#\*Meta\.Doc\.Lib\.Table\,in\:\@\.\.\.\%\)\:void";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my %in = @_[1..$#_]; 
  #----------------------------
  # META: start of user-code
  my %row;
  my $map = $self->colMap();
  foreach my $k (keys(%in)) {
    my $col = $self->colForId($k);
    if ( $col ) {
      my $v = $in{$k};
      $row{$k} = $v;
      $col->monitor($v||'');
    } else {
      print(STDERR "WARN: '$k' is not a legal column id (ignored)\n");
    }
  }
  $self->addRow(\%row);
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'addRow'
# META: Meta.Doc.Lib.Table.addRow(#*Meta.Doc.Lib.Table,*Meta!Map):void
sub addRow {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.addRow\(self\:\#\*Meta\.Doc\.Lib\.Table\,row\:\*Meta\!Map\)\:void";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my $row = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$row failed typechecking.  Possible reasons are:\n   - \$row has ref '%s' when ref 'HASH' expected",(defined($row)?ref($row):'undef'))) if ( (((defined($row)) && (ref($row) ne 'HASH'))) );
  #----------------------------
  # META: start of user-code
  push(@{$self->rows()}, $row);
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'footer'
# META: Meta.Doc.Lib.Table.footer(#*Meta.Doc.Lib.Table):@Meta!Str
sub footer {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.footer\(self\:\#\*Meta\.Doc\.Lib\.Table\)\:\@Meta\!Str";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  #----------------------------
  # META: start of user-code
  return $self->name() . ': ' . $self->caption();
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'print'
# META: Meta.Doc.Lib.Table.print(#*Meta.Doc.Lib.Table,@...%):void
sub print {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.print\(self\:\#\*Meta\.Doc\.Lib\.Table\,options\:\@\.\.\.\%\)\:void";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my %options = @_[1..$#_]; 
  #----------------------------
  # META: start of user-code
  my $fp = \*STDOUT;

  ####
  ## First the header
  my $header = $self->formatHeader();
  my $width  = length($header);
  my $sep    = ('='x$width) . "\n";
  my $subsep = ('-'x$width) . "\n";

  print($fp $sep, $self->formatHeader(), "\n", $subsep);

  ####
  ## Now the data
  my $rows  = $self->rows();
  foreach my $index (0..$#$rows) {
    print($fp $self->formatRow($index), "\n");
  }
  print($fp $subsep, $self->footer(), "\n", $sep);
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'formatRow'
# META: Meta.Doc.Lib.Table.formatRow(#*Meta.Doc.Lib.Table,@int):@Meta!Str
sub formatRow {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.formatRow\(self\:\#\*Meta\.Doc\.Lib\.Table\,index\:\@int\)\:\@Meta\!Str";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my $index = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$index failed typechecking.  Possible reasons are:\n   - \$index has ref '%s' when ref '' expected",(defined($index)?ref($index):'undef'))) if ( (((defined($index)) && (ref($index) ne ''))) );
  #----------------------------
  # META: start of user-code
  my $result = '';
  my $order = $self->colOrder();
  my $row = $self->rows()->[$index];
  if ( defined($row) ) {
    foreach my $id (@$order) {
      my $col = $self->colForId($id);
      my $v   = $row->{$id};
      if ( ! defined($v) ) { $v = ''; } ## IS THIS THE CORRECT THING TO DO??  Added because the new Meta compiler disallows undef values for arguments of Meta!Str@ type (see Column::format, called below)
      my $fv  = $col->format($v);
      $result .= $fv;
    }
  } else {
    printf(STDERR "WARN: Table %s does not have a row at index $index\n");
    $result = undef;
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'formatHeader'
# META: Meta.Doc.Lib.Table.formatHeader(#*Meta.Doc.Lib.Table):@Meta!Str
sub formatHeader {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.formatHeader\(self\:\#\*Meta\.Doc\.Lib\.Table\)\:\@Meta\!Str";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  #----------------------------
  # META: start of user-code
  my $result = '';
  my $order = $self->colOrder();
  foreach my $id (@$order) {
    my $col = $self->colForId($id);
    my $fv  = $col->format($col->label(), 's');
    $result .= $fv;
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_main'
# META: Meta.Doc.Lib.Table.__meta_main(@Meta!Str,*Meta!Vec<@Meta!Str>,@boolean,@int):void
sub __meta_main {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.__meta_main\(exec\:\@Meta\!Str\,args\:\*Meta\!Vec\<\@Meta\!Str\>\,validate\:\@boolean\,verbose\:\@int\)\:void";
  my $exec = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$exec failed typechecking.  Possible reasons are:\n   - \$exec must be defined and have ref '' (is '%s')",(defined($exec)?ref($exec):'undef'))) if ( (((!defined($exec)) || (ref($exec) ne ''))) );
  my $args = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$args failed typechecking.  Possible reasons are:\n   - \$args has ref '%s' when ref 'ARRAY' expected",(defined($args)?ref($args):'undef'))) if ( (((defined($args)) && (ref($args) ne 'ARRAY'))) );
  my $validate = $_[2]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$validate failed typechecking.  Possible reasons are:\n   - \$validate has ref '%s' when ref '' expected",(defined($validate)?ref($validate):'undef'))) if ( (((defined($validate)) && (ref($validate) ne ''))) );
  my $verbose = $_[3]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$verbose failed typechecking.  Possible reasons are:\n   - \$verbose has ref '%s' when ref '' expected",(defined($verbose)?ref($verbose):'undef'))) if ( (((defined($verbose)) && (ref($verbose) ne ''))) );

  {
    # Main method unit-testing prolog
    if ( $validate ) {
      print(STDERR "NOTE: Executing unit test for 'Table' (stdout and stderr redirected)\n");
      close(STDOUT); open(STDOUT, ">Table.out");
      close(STDERR); open(STDERR, ">Table.err");
    } 
  }
  #----------------------------
  # META: start of user-code
  my $table = Meta::Doc::Lib::Table->new(
    { 
      name => 'Table 3-1', 
      caption => 'A comparison of age and height',
      defaults => { type => 'str', width => 10 },
    },
    'name',
    'age', 
    'height', { type => 'real.2', width => 5 },
  );
  $table->summary();

  $table->add( name => 'Bob',   age => 20, height => 1.87 );
  $table->add( name => 'Alice', age => 27, height => 1.5 );
  $table->add( name => 'Henry', age => 31, height => 1.763921 );
  $table->print();

  printf("The value of 'height' for 'name' 'Alice' is %s\n", $table->entryFor('name', 'Alice', 'height'));

  my $table2 = $table->transpose('name');
  $table2->print();

  printf("The value of 'Henry' for 'name' 'Height' is %s\n", $table2->entryFor('name', 'Height', 'Henry'));

  my $file = $args->[0];
  if ( $file ) {
    my $fp = IO::File->new("<$file") || die("ERROR: Failed to open '$file' for reading");
    my $table3 = Meta::Doc::Lib::Table::newFromFp($fp);
    $table3->print();
  }
  # META: end of user-code
  #----------------------------
  {
    # Main method unit-testing epilog
    if ( $validate ) {
      my $tty = `tty`; chomp($tty);
      close(STDOUT); open(STDOUT, ">$tty");
      close(STDERR); open(STDERR, ">$tty");
      my $errors = &__meta_validate($validate);
      if ( ( -s 'Table.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat Table.out"); } unlink('Table.out') unless ( $verbose > 2);
      if ( ( -s 'Table.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat Table.err"); } unlink('Table.err') unless ( $verbose > 2);
    } 
  }
}

###############################
# static METHOD '__meta_validate'
# META: Meta.Doc.Lib.Table.__meta_validate(@int):@int
sub __meta_validate {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.__meta_validate\(verbose\:\@int\)\:\@int";
  my $verbose = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$verbose failed typechecking.  Possible reasons are:\n   - \$verbose has ref '%s' when ref '' expected",(defined($verbose)?ref($verbose):'undef'))) if ( (((defined($verbose)) && (ref($verbose) ne ''))) );
  #----------------------------
  # META: start of user-code
  my $errors = 0;
  print("NOTE:    No unit testing provided for CLASS Table\n");
  return $errors;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD '__meta_initInstance'
# META: Meta.Doc.Lib.Table.__meta_initInstance(#*Meta.Doc.Lib.Table,@int):@int
sub __meta_initInstance {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.__meta_initInstance\(self\:\#\*Meta\.Doc\.Lib\.Table\,verbose\:\@int\)\:\@int";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::Table' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::Table')))) );
  my $verbose = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$verbose failed typechecking.  Possible reasons are:\n   - \$verbose has ref '%s' when ref '' expected",(defined($verbose)?ref($verbose):'undef'))) if ( (((defined($verbose)) && (ref($verbose) ne ''))) );
  #----------------------------
  # META: start of user-code
  $_[0]->SUPER::__meta_initInstance();
  $_[0]->__meta_extend({
         '__meta_colMap'      => {},
         '__meta_colOrder'    => [],
         '__meta_colWidths'   => {},
         '__meta_rows'        => [],
         '__meta_caption'     => 0,
         '__meta_name'        => 0,
         '__meta_defaults'    => {},
  });
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_initStatic'
# META: Meta.Doc.Lib.Table.__meta_initStatic():void
sub __meta_initStatic {
  my $__meta_sig = "Meta\.Doc\.Lib\.Table\.__meta_initStatic\(\)\:void";
  #----------------------------
  # META: start of user-code
  # META: end of user-code
  #----------------------------
}
&__meta_initStatic();


sub __Meta_main { &__meta_main(@_); }


###
# All well-formed perl modules return true.
1;

  
