package Meta::Lib::Object;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Lib::Root);
use Meta::Lib::Root;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Oopl::BaseLanguage::PerlRef;

###
# The executable code of this class (methods, accessors, initializers, finalizers)


###############################
# static METHOD '__meta_main'
# META: Meta.Lib.Object.__meta_main(@Meta!Str,*Meta!Vec<@Meta!Str>,@boolean,@int):void
sub __meta_main {
  my $exec = $_[0]; 
  my $args = $_[1]; 
  my $validate = $_[2]; 
  my $verbose = $_[3]; 

  {
    # Main method unit-testing prolog
    if ( $validate ) {
      print(STDERR "NOTE: Executing unit test for 'Object' (stdout and stderr redirected)\n");
      close(STDOUT); open(STDOUT, ">Object.out");
      close(STDERR); open(STDERR, ">Object.err");
    } 
  }
  #----------------------------
  # META: start of user-code
  # Main method core
  print("No RUN attribute was specified for CLASS Object\n");
  # META: end of user-code
  #----------------------------
  {
    # Main method unit-testing epilog
    if ( $validate ) {
      my $tty = `tty`; chomp($tty);
      close(STDOUT); open(STDOUT, ">$tty");
      close(STDERR); open(STDERR, ">$tty");
      my $errors = &__meta_validate($validate);
      if ( ( -s 'Object.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat Object.out"); } unlink('Object.out') unless ( $verbose > 2);
      if ( ( -s 'Object.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat Object.err"); } unlink('Object.err') unless ( $verbose > 2);
    } 
  }
}

###############################
# static METHOD '__meta_validate'
# META: Meta.Lib.Object.__meta_validate(@int):@int
sub __meta_validate {
  my $verbose = $_[0]; 
  #----------------------------
  # META: start of user-code
  my $errors = 0;
  print("NOTE:    No unit testing provided for CLASS Object\n");
  return $errors;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD '__meta_initInstance'
# META: Meta.Lib.Object.__meta_initInstance(#*Meta.Lib.Object,@int):@int
sub __meta_initInstance {
  my $self = $_[0]; 
  my $verbose = $_[1]; 
  #----------------------------
  # META: start of user-code
  $_[0]->SUPER::__meta_initInstance();
  $_[0]->__meta_extend({
  });
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_initStatic'
# META: Meta.Lib.Object.__meta_initStatic():void
sub __meta_initStatic {
  #----------------------------
  # META: start of user-code
  # META: end of user-code
  #----------------------------
}
&__meta_initStatic();


sub __Meta_main { &__meta_main(@_); }


###
# All well-formed perl modules return true.
1;

  
