package XFig::BasicObject;
use strict;

=head1 NAME

XFig::BasicObject -

=head1 SYNOPSIS

use XFig::BasicObject ();

=head1 DESCRIPTION
Abstract superclass of:
=head1      ARC
=head1      ELLIPSE
=head1      POLYLINE
=head1      SPLINE
=head1      TEXT

=head1 NOTES


=head1 EXAMPLES


=head1 IMPLEMENTATION

=cut

use Carp;                      # everyone gets Carp!
use IO::File;                  # everyone gets IO::File!
use IO::File;
use XFig::Object;
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
@ISA = qw(XFig::Object);
$VERSION = '0.01';

####################### Package Global Variables ###################
use vars qw();




############################# Raw Code  ############################
				      
				      
########################## Class Methods ###########################

#line 2111 "fig.pxx"
sub new {
    carp('Usage: XFig::BasicObject::new(class, args)') unless (@_ == 2);
    my($class) = $_[0]; CORE::ref($class) eq '' or carp(sprintf('XFig::BasicObject::new: ref($class) = %s instead of .', CORE::ref($class))); 
    my($args) = $_[1]; ((!$args) || (CORE::ref($args) eq 'HASH')) or carp(sprintf('XFig::BasicObject::new: ref($args) = %s instead of HASH.', ref($args))); 
#line 2112 "fig.pxx"
    &XFig::Object::adjustArgs($args);
    my $self = $class->SUPER::new($args);
    $self->initFields($args, qw(sub_type depth pen_color pen_style));
    return $self;
}

########################## Instance Methods ########################

###
# Accessors
#line 2105 "fig.pxx"
sub depth                {  return ( $#_ == 0 ) ? $_[0]->{depth} : ( $_[0]->{depth} = $_[1] );  }
#line 2105 "fig.pxx"
sub incrDepth            {  return $_[0]->{depth} += (defined($_[1]) ? $_[1] : 1); }
#line 2106 "fig.pxx"
sub incrPen_color        {  return $_[0]->{pen_color} += (defined($_[1]) ? $_[1] : 1); }
#line 2107 "fig.pxx"
sub incrPen_style        {  return $_[0]->{pen_style} += (defined($_[1]) ? $_[1] : 1); }
#line 2104 "fig.pxx"
sub incrSub_type         {  return $_[0]->{sub_type} += (defined($_[1]) ? $_[1] : 1); }
#line 2106 "fig.pxx"
sub pen_color            {  return ( $#_ == 0 ) ? $_[0]->{pen_color} : ( $_[0]->{pen_color} = $_[1] );  }
#line 2107 "fig.pxx"
sub pen_style            {  return ( $#_ == 0 ) ? $_[0]->{pen_style} : ( $_[0]->{pen_style} = $_[1] );  }
#line 2104 "fig.pxx"
sub sub_type             {  return ( $#_ == 0 ) ? $_[0]->{sub_type} : ( $_[0]->{sub_type} = $_[1] );  }
# End Accessors
###

###
# User Code
#line 1 "GENERATED CODE"
sub initState {
    carp('Usage: XFig::BasicObject::initState(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::BasicObject'))) or carp(sprintf('XFig::BasicObject::initState: NOT $self->isa(XFig::BasicObject)')); 
#line 3 "GENERATED CODE"
{
    $_[0]->SUPER::initState();
    $_[0]->extend({
        # pen_color => '',
        # sub_type => '',
        # pen_style => '',
        # depth => '',
    });
}}

#line 2120 "fig.pxx"
sub setPenColor {
    carp('Usage: XFig::BasicObject::setPenColor(self, color)') unless (@_ == 2);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::BasicObject'))) or carp(sprintf('XFig::BasicObject::setPenColor: NOT $self->isa(XFig::BasicObject)')); 
    my($color) = $_[1]; CORE::ref($color) eq '' or carp(sprintf('XFig::BasicObject::setPenColor: ref($color) = %s instead of .', CORE::ref($color))); 
#line 2121 "fig.pxx"
    my $ci = &XFig::XFig::colorIndexFor($color);
    if ( defined($ci) ) {
        #print(STDERR "NOTE: Setting pen color to $color ($ci)\n");
    } else {
        print(STDERR "WARN: Failed to find color '$color' - using default\n");
        $ci = $XFig::XFig::Types{color}->{Default};
    }
    $self->pen_color($ci);
    return $ci;
}
# User Code
###

###
# Post text

# Post text
###

########################## END OF MODULE ###########################
1;

__DATA__


__END__

=head1 PUBLIC CLASS INTERFACE

=over 4



=head1 PUBLIC INSTANCE INTERFACE

=over 4

=head2 initState()
Automated method for initializing Perl class state based on field definitions.

=cut

=head1 AUTHOR

Wade Holst

=head1 SEE ALSO

perl(1).

=cut         